from haystack.views import search_view_factory, FacetedSearchView
from haystack.forms import FacetedSearchForm
from haystack.query import SearchQuerySet


class SearchView(FacetedSearchView):
    def extra_context(self):
        context = super(SearchView, self).extra_context()
        context['sectionName'] = 'Search'
        context['selected_categories'] = [
                x.split(':', 1)[1] for x in self.request.GET.getlist('selected_facets')
                if x.startswith('categories_exact')]
        context['selected_tags'] = [
                x.split(':', 1)[1] for x in self.request.GET.getlist('selected_facets')
                if x.startswith('tags_exact')]
        return context

sqs = SearchQuerySet().facet('categories').facet('tags')

view = search_view_factory(SearchView,
        form_class=FacetedSearchForm,
        searchqueryset=sqs)
