$(function() {

	doLog = function(aTextToLog, type){
		var aLog = $('<div>',{class:"log "+type,html:aTextToLog});
		aLog.hide().prependTo($log).show('fast').delay(3000).hide('fast', function() { 
			$(this).remove(); 
		});
	}
	var $main = $("#Changing");
	var $metaNav = $("#metaNav");
	var $log = $("#userLog");
	$( document ).tooltip({
		position: {
			my: "center bottom-5",
			at: "center top",
			using: function( position, feedback ) {
				$( this ).css( position );
				$( "<div>" )
				.addClass( "arrow" )
				.addClass( feedback.vertical )
				.addClass( feedback.horizontal )
				.appendTo( this );
			}
		}
	});
	$('body').css({'min-height':$(window).height() + $('#Commons').height()});
	/****************************************************/
	/**** AJAX UTILITIES FOR REQUESTS ****/
	/****************************************************/
	String.prototype.decodeHTML = function() {
		return $("<div>", {html: "" + this}).html();
	};
	var loadPage_request = null;
	afterLoad = function(html, textStatus, XMLHttpRequest) {
		loadPage_request = null;
		if (textStatus == "error") {
			doLog('Sorry! And error occur when loading page content','error');
		}
		new_content = $($.parseHTML(html)).find('#Changing>*');
		$main.hide().empty().append(new_content).show();

		new_menu = $($.parseHTML(html)).find('#metaNav>*');
		$metaNav.empty().append(new_menu);

		var newTitle = html?html.match(/<title>(.*?)<\/title>/):'';
		if(newTitle){document.title = newTitle[1].trim().decodeHTML();}

		if (typeof (Piwik) == 'object') {
			piwikTracker = Piwik.getAsyncTracker();
			if (typeof (piwikTracker.trackPageView) == 'function') {
				piwikTracker.setDocumentTitle(document.title);
				piwikTracker.setCustomUrl(window.location.href);
				piwikTracker.trackPageView();
			}
		}

		/*
		Quite UGLY but needed for styling the whole body with ID
		Feel free to correct and find a better way
		According to this link the probles is that $(html).filter('body').Attr('id') will not work!
		http://www.devnetwork.net/viewtopic.php?f=13&t=117065
		*/
		if(sectionName = $(html).find('[data-section]').attr('data-section')){
			$('body').attr('id',sectionName);
		}else{
			var bodyID = html.match(/<body id="(.*?)">/);	
			if(bodyID){$('body').attr('id',bodyID[1].trim());}	
		}
		$("#Changing").css({'min-height':$(window).height()});
		$.scrollTo('#Changing',1000,{offset:-$('#metaNav').height()+2});
		init();
	};

	function afterLoadError(xhr, text, error) {
		afterLoad(xhr.responseText, 'error', xhr);
	};

	$(window).on("popstate", function(e) {
		if (e.originalEvent.state !== null) {loadPage(location.href);}
	});

	loadPage = function(href) {
		history.pushState({}, '', href);
		if (loadPage_request !== null) {
			loadPage_request.abort();
		}
		loadPage_request = $.ajax({
			url: href,
			success: afterLoad,
			error: afterLoadError,
			dataType: 'html'});
	};
        $.fn.ajaxifyClick = function(params) {
		this.each(function() {
			$(this).unbind('click');
			$(this).bind('click',function(){
				$(this).addClass('loading');
				var href = $(this).attr("href");
				/* this checks the link points to a local document, be
				 * it because it's just a path, or because the server
				 * part points to the same domain */
				if (!href) {
					doLog('No href attributes, unable to load content','error');
					$("#All a, #All area").removeClass('loading');
					return false;
				}else if (!$(this).attr('target') && (
						href.indexOf(document.domain) > -1 ||href.indexOf(':') === -1 || href.indexOf(':') > 5
					)) {
					loadPage(href);
					return false;
				}else{
					$(this).attr('target','_blanck');
					$("#All a, #All area").removeClass('loading');
					return true;
				}
			});
		});
	};
	/****************************************************/
	/**** AUDIOPLAYER ****/
	/****************************************************/

	var timer = null, 
	interval = 5000;
	/*
	//TODO: mini icon version for player, (playpause only)
	$('#togglePlayer').on('click',function(e) {
		e.preventDefault();
		if($(this).is('.icon-double-angle-left')){
			$("#player").fadeOut('fast',function(){
				$("#player-container").toggleClass('minimized');			
				$('#togglePlayer').toggleClass('icon-double-angle-left icon-double-angle-right');
			});			
		}else{
			$("#player").fadeIn('fast',function(){
				$("#player-container").toggleClass('minimized');			
				$('#togglePlayer').toggleClass('icon-double-angle-left icon-double-angle-right');
			});	
		}
		return false;
	});
	*/
	$('#WhatsOnAir').on('load',function(){
		var WhatsOnAir = $(this);
		$.getJSON('/onair.json', function(onair) {
			WhatsOnAir.fadeOut();
			if(onair.data.episode || onair.data.emission){
				var onairContainer = $('<span>');
				if(onair.data.emission){
					$('<a>',{href:onair.data.emission.url,html:onair.data.emission.title}).appendTo(onairContainer).ajaxifyClick();
				}
				if(onair.data.episode){
					$('<a>',{href:onair.data.episode.url,html:onair.data.episode.title}).appendTo(onairContainer).ajaxifyClick();
				}
				WhatsOnAir.empty().append(onairContainer);
			} else if (onair.data.nonstop) {
				result = onair.data.nonstop.title;
				WhatsOnAir.html('<span>' + result + '</span>');
			}
			else{WhatsOnAir.html('<span>Unknown (Probably Non-Stop)</span>');}
			WhatsOnAir.fadeIn();
		});
	}).trigger('load');
	$('#RefreshWhatsOnAir').on('activate',function(e){
		$(this).addClass('spinning');
		$('#WhatsOnAir').addClass('active');
		$('#WhatsOnAir').trigger('load');
		timer = setInterval( "$('#WhatsOnAir').trigger('load');", interval);
	}).on('deactivate',function(e){
		$(this).removeClass('spinning');
		$('#WhatsOnAir').removeClass('active');
		clearInterval(timer);
	}).on('click',function(e){
		$(this).toggleClass('spinning');
		if($(this).is('.spinning')){
			$(this).trigger('activate');						
		}else{$(this).trigger('deactivate');}
		return false;
	});
	$("#DirectStreamPanikControler").on('click',function(e) {
		e.preventDefault();
		var stream = $('#DirectStreamPanik').get(0);
		if (stream.paused == false){
			stream.pause();
		}else{
			stream.play();
		}
		return false;
	});
	$('#DirectStreamPanik').on('play',function(){
		$('audio:not(#DirectStreamPanik)').each(function(){this.pause();});
		$('#streamSymbol').removeClass('icon-volume-up').addClass('icon-pause');
		$('#RefreshWhatsOnAir').trigger('activate');
	}).on('pause',function(){
		//$('audio:not(#DirectStreamPanik)').each(function(){this.pause();});
		$('#streamSymbol').addClass('icon-volume-up').removeClass('icon-pause');
		$('#RefreshWhatsOnAir').trigger('deactivate');
	});
	if($('#player-container').offset()){
		var topPosition = 0;
		topPosition = $('#player-container').offset().top;
		$(window).bind('scroll load',function (event) {
			//$('#player-container').removeClass('fixed');
			var y = $(this).scrollTop() + $('#metaNav').height() - $('#Player').height() + 10;
			if (topPosition!== 0 && y >= topPosition) {
				$('#Player').css({'min-height':$('#Player').height()});
				$('#player-container').addClass('fixed').removeClass('normal');
			} else {
				$('#Player').css({'min-height':'auto'});	
				$('#player-container').removeClass('fixed').addClass('normal');
			}
		});
	}

	var $localList = $('#localList').playlist({
		controlContainer: $('<div>',{class:"playListControls"}).sortable(),
		playlistContainer: $('<ol>',{id:"myPlaylist",class:"custom"}).sortable(),
		onLoad:function(self){
			$('#toggleList').on('click',function(){ 
				self.playlistContainer.toggleClass('deploy');
			});
			$('#emptyList').on('click',function(){ 
				self._reset();
			});

			if(self.isActive){
				self.playlistContainer.scrollTo(self.isActive, 800 );
				self.isActive.find('audio').attr('preload',"preload")
			}
			self.controlButtons['playpause'].addClass('resymbol');
		},
		onPlay:function(self){
			$('#DirectStreamPanik')[0].pause();
			self.playlistContainer.scrollTo(self.isActive, 800 );
		},
		onAdd:function(self){
			//self.isLastAdd[0].scrollIntoView();
			self.isLastAdd.find('a').ajaxifyClick();
			self.playlistContainer.scrollTo(self.isLastAdd, 800).delay(1000).scrollTo(self.isActive, 800 ).clearQueue();

		},
		onUpdate:function(self){
			//doLog(JSON.stringify(self.playlist, null, '\t'));	
			if(self.playlist.length >= 1){
				self.element.show();
				$('#Player').addClass('withPlaylist');
			}else{
				self.element.hide();
				$('#Player').removeClass('withPlaylist');
			}
		}
	});

	init = function() {
		$("#All a, #All area").removeClass('loading');
		$("#All a, #All area").ajaxifyClick();
		$("#search-form").unbind('submit').on('submit', function(event) {
			event.preventDefault();
			$(this).addClass('loading');
			loadPage($(this).attr('action') + '/?' + $(this).serialize());
		});
		$(".tabs").each(function() {
			var self = $(this);
			var about= $($(this).attr("data-tab-about"));
			var current = $(this).find("[data-tab].active")[0];
			var dftShowSelector = current?".active":":first";
			var activeTab = $(this).find("[data-tab]"+dftShowSelector+"").addClass("active");
			$(this).find("[data-tab]").each(function() {
			    $(this).on('click load',function (e) {  
				e.preventDefault();
				self.find(".active").removeClass("active");  
				$(this).addClass("active");  
				about.find("[data-tabbed]").hide();  
				$($(this).attr("data-tab")).fadeIn();  
		
			    });  
			});  
			activeTab.trigger('load');
		});
		$('[data-player-action]').on('click',function(){
			var audio = $('#'+$(this).attr('data-player-audio'));
			if($(this).attr('data-player-action') == "registerAudio"){
				$localList.playlist("registerAudio",audio,doLog(audio.attr('title')+' has been added to your playlist.','ok'));
			}else if($(this).attr('data-player-action') == "playAudio"){
				$localList.playlist("registerAudio",audio,doLog(audio.attr('title')+' will play soon.','ok'));
				$localList.playlist("playLast");
			}else{
				$localList.playlist($(this).attr('data-player-action'));
			}
		});
		$('[data-player-control]').each(function(){
			var audio = $('#'+$(this).attr('data-player-audio'));
			$localList.playlist("bindControl",$(this).attr('data-player-control'),audio,$(this));
		});

		$('[data-highlight]').on('check',function(){
			$($(this).attr('data-about')).find($(this).attr('data-highlight')).addClass('highlighted').removeClass('normal');
		}).on('uncheck',function(){
			$($(this).attr('data-about')).find($(this).attr('data-highlight')).removeClass('highlighted').addClass('normal');
		}).on('click',function(){
			$(this).toggleClass('icon-check icon-check-empty');
			if($(this).hasClass('icon-check')){$(this).trigger('check');
			}else{	$(this).trigger('uncheck');}
		});
		$('[data-highlight].icon-check-empty').each(function(){
			$(this).trigger('uncheck');
		});
		$('[data-toggle]').on('check',function(){
			$($(this).attr('data-about')).find($(this).attr('data-toggle')).show();
		}).on('uncheck',function(){
			$($(this).attr('data-about')).find($(this).attr('data-toggle')).hide();
		}).on('click',function(){
			$(this).toggleClass('icon-check icon-check-empty');
			if($(this).hasClass('icon-check')){$(this).trigger('check');
			}else{	$(this).trigger('uncheck');}
		});
		$('[data-toggle].icon-check-empty').each(function(){
			$(this).trigger('uncheck');
		});
		if ($('input#id_q').val() == '') {
			$('input#id_q').focus();
		}
	}
	init();
});
